/* entryslider.h
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#ifndef N96_DRAW_entryslider_h
#define N96_DRAW_entryslider_h

#include "commongui.h"
typedef struct EntrySlider EntrySlider;
typedef struct _ngg_vtab_t_EntrySlider {
} _ngg_vtab_t_EntrySlider;

typedef struct EntrySlider {
	_ngg_vtab_t_EntrySlider _ngg_vtab_entry_slider;
	struct _ngg_vtab_t_ngg_custwid _ngg_vtab_ngg_custwid;
	GtkScale *sldr;
	GtkSpinButton *spnbtn;
	GtkLabel *lbl;
	GtkGrid *grd;
	void (*changed_callback)(EntrySlider *widget, void *user_data);
	void *changed_data;
	_Bool set_by_code;
} EntrySlider;

static inline GtkGrid* entry_slider_get_native_widget(EntrySlider * this) {
return this->grd;
}
void entry_slider_construct(EntrySlider *this);
_Bool entry_slider_get_sensitive(EntrySlider *this);
double entry_slider_get_value(EntrySlider *this);
void entry_slider_set_increments(EntrySlider *this, double stp, double page);
void entry_slider_set_label(EntrySlider *this, const char * s);
void entry_slider_set_sensitive(EntrySlider *this, _Bool sensitive);
void entry_slider_set_value(EntrySlider *this, double value);
void entry_slider_set_value_by_code(EntrySlider *this, double value);
void entry_slider_set_onchanged(EntrySlider *this, void (*callback)(EntrySlider *widget, void *user_data), void *user_data);
void entry_slider_set_range(EntrySlider *this, double min, double max);
void entry_slider_show(EntrySlider *this);
void entry_slider_on_spnbtn_changed(GtkSpinButton *widget, void *user_data);
void entry_slider_destruct(EntrySlider *this);

#endif /* N96_DRAW_entryslider_h */
