/* floodfill.h
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#ifndef N96_DRAW_floodfill_h
#define N96_DRAW_floodfill_h

#include "core.h"
typedef struct Point {
	int x;
	int y;
} Point;

typedef struct PointStack PointStack;
typedef struct _ngg_vtab_t_PointStack {
} _ngg_vtab_t_PointStack;

typedef struct PointStack {
	_ngg_vtab_t_PointStack _ngg_vtab_point_stack;
	Point *arr;
	size_t count;
	size_t alloccount;
} PointStack;

typedef struct BooleanMap BooleanMap;
typedef struct _ngg_vtab_t_BooleanMap {
} _ngg_vtab_t_BooleanMap;

typedef struct BooleanMap {
	_ngg_vtab_t_BooleanMap _ngg_vtab_boolean_map;
	Image *img;
} BooleanMap;

void point_stack_construct(PointStack *this);
void point_stack_destruct(PointStack *this);
_Bool point_stack_is_empty(PointStack *this);
void point_stack_push(PointStack *this, Point newitem);
void point_stack_push_multiple(PointStack *this, size_t n, Point *newitems);
Point point_stack_peek(PointStack *this);
Point point_stack_pop(PointStack *this);
Point point_stack_pop_bottom(PointStack *this);
void point_stack_replace_top(PointStack *this, Point newitem);
void point_stack__resize(PointStack *this, size_t newcount);
void boolean_map_construct(BooleanMap *this, int w, int h);
_Bool boolean_map_get(BooleanMap *this, int x, int y);
_Bool boolean_map_set(BooleanMap *this, int x, int y);
void boolean_map_destruct(BooleanMap *this);
struct Rectangle nan_img_floodfill(Image *img, int x, int y, struct DrawingParams dp);
void floodfill_add_point_to_stack_if_match(Image *img, PointStack *ptstack, BooleanMap *donemap, Point point, struct Pixel ifpxl);
Point point_default();

#endif /* N96_DRAW_floodfill_h */
