/* layer.c
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#include <assert.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

#include "layer.h"

void layer_construct(Layer *this, int width, int height, struct Pixel default_bgcolor)
{
	this->default_bgcolor = default_bgcolor;

	Image * _ngg_tmp_0 = malloc(sizeof(Image));
	if(_ngg_tmp_0 == NULL) { perror(NULL); exit(EXIT_FAILURE); }
	image_construct(_ngg_tmp_0, width, height, 255);
	this->img = _ngg_tmp_0;
	image_fill(this->img, default_bgcolor);
}

void layer_replace_image(Layer *this, Image *newimg)
{
	if(this->img) {
		image_destruct(this->img);
		free(this->img);
	}

	this->img = NULL;
	this->img = newimg;
}

void layer_destruct(Layer *this)
{
	if(this->img) {
		image_destruct(this->img);
		free(this->img);
	}

	this->img = NULL;
}

