/* layer.h
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#ifndef N96_DRAW_layer_h
#define N96_DRAW_layer_h

#include "core.h"
typedef struct Layer Layer;
typedef struct _ngg_vtab_t_Layer {
} _ngg_vtab_t_Layer;

typedef struct Layer {
	_ngg_vtab_t_Layer _ngg_vtab_layer;
	Image *img;
	struct Pixel default_bgcolor;
} Layer;

void layer_construct(Layer *this, int width, int height, struct Pixel default_bgcolor);
void layer_replace_image(Layer *this, Image *newimg);
void layer_destruct(Layer *this);

#endif /* N96_DRAW_layer_h */
