/* newdocdialog.h
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#ifndef N96_DRAW_newdocdialog_h
#define N96_DRAW_newdocdialog_h

#include "commongui.h"
typedef struct NewDocDialog NewDocDialog;
typedef struct _ngg_vtab_t_NewDocDialog {
} _ngg_vtab_t_NewDocDialog;

typedef struct NewDocDialog {
	_ngg_vtab_t_NewDocDialog _ngg_vtab_new_doc_dialog;
	GtkButton *btn_swap;
	GtkSpinButton *spin_height;
	GtkLabel *lbl2;
	GtkSpinButton *spin_width;
	GtkLabel *lblwidth;
	GtkGrid *grd;
	GtkButton *btn_preset_a4_300ppi;
	GtkButton *btn_preset_a4_150ppi;
	GtkButton *btn_preset_fhd;
	GtkBox *hbx_presets;
	GtkBox *vbx_main;
	GtkDialog *dlg;
	int maxwidth;
} NewDocDialog;

typedef struct _ngg_tuple_run {
	_Bool m0;
	int m1;
	int m2;
} _ngg_tuple_run;

void new_doc_dialog_construct(NewDocDialog *this, GtkWindow *parent, int maxwidth);
void new_doc_dialog_destruct(NewDocDialog *this);
void new_doc_dialog_apply_preset(NewDocDialog *this, int w, int h);
_ngg_tuple_run new_doc_dialog_run(NewDocDialog *this);
void new_doc_dialog_on_btn_preset_clicked(GtkButton *widget, void *user_data);
void new_doc_dialog_on_btn_swap_clicked(GtkButton *widget, void *user_data);

#endif /* N96_DRAW_newdocdialog_h */
