/* pixel.c
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#include <assert.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

#include "pixel.h"

void nan_pixel_assert(Pixel pixel)
{
	int i;
	#ifdef DEBUG
	for(i = 0; i < 4; ++i) {
		assert(pixel.rgb[i] >= 0 && pixel.rgb[i] <= 1); /* pixel.ngg:15 */
	}

	#endif
}

Pixel rgbpixel_with_alpha(Pixel pixel, double a)
{
	int i;
	nan_pixel_assert(pixel);
	assert(1 == pixel.rgb[3]); /* pixel.ngg:22 */
	for(i = 0; i < 3; ++i) {
		pixel.rgb[i] = pixel.rgb[i] * a;
	}

	pixel.rgb[3] = a;
	nan_pixel_assert(pixel);

	return pixel;
}

Pixel pixel_default()
{
	Pixel s;

	return s;
}

