/* quickpalette.h
 * This file is part of Vara digital painting program
 * Copyright 2021, 2023 Nandakumar Edamana
 * Distributed under GNU General Public License, version 3
 */ 

#ifndef N96_DRAW_quickpalette_h
#define N96_DRAW_quickpalette_h

#include "imageview.h"
#define NSHADES (12)
typedef struct QuickPalette QuickPalette;
typedef struct _ngg_vtab_t_QuickPalette {
} _ngg_vtab_t_QuickPalette;

typedef struct QuickPalette {
	_ngg_vtab_t_ImageView _ngg_vtab_image_view;
	struct _ngg_vtab_t_ngg_custwid _ngg_vtab_ngg_custwid;
	GtkDrawingArea *da;
	Image *img;
	cairo_surface_t *surf;
	_Bool autoresize;
	_ngg_vtab_t_QuickPalette _ngg_vtab_quick_palette;
	void (*oncolorset_callback)(QuickPalette *widget, struct Pixel eventcolor, void *user_data);
	void *oncolorset_data;
	int curw;
	int curh;
	struct Pixel selcolor;
} QuickPalette;

typedef struct _ngg_tuple_get_color_at {
	struct Pixel m0;
	_Bool m1;
	_Bool m2;
} _ngg_tuple_get_color_at;

void quick_palette_construct(QuickPalette *this);
_Bool quick_palette_on_da_event(GtkWidget *widget, GdkEvent *event, void *user_data);
void quick_palette_on_da_sizeallocate(GtkDrawingArea *widget, GdkRectangle *nggevent_allocation, void *user_data);
void quick_palette_set_hexpand(QuickPalette *this, _Bool expand);
_ngg_tuple_get_color_at quick_palette_get_color_at(QuickPalette *this, int x, int y);
void quick_palette_destruct(QuickPalette *this);
void fill_spectrum(Image *img, struct Pixel basecolor, _Bool redraw_spectrum);

#endif /* N96_DRAW_quickpalette_h */
